Codeforces 756C Nikita and stack】的更多相关文章

Codeforces 756C Nikita and stack 题目大意: 给定一个对栈进行操作的操作序列,初始时序列上没有任何操作,每一次将一个本来没有操作的位置变为某一操作(push(x),pop()).在每一次变化后输出按照顺序执行操作序列最后得到的栈顶元素.对空栈pop()没有任何作用. 题解: 容易发现我们只用关心栈顶元素,而不用管其他的元素 而一个被push的元素成为栈顶的条件是操作序列中在它后面的元素全部都被pop了 所以问题转化成了求最大的一个push的操作,满足在它后面的pu…
就是给你一些元素的进栈 出栈操作,不按给定的顺序,要求你对于每次输入,都依据其及其之前的输入,判断出栈顶的元素是谁. 用线段树维护,每次push,将其位置的值+1,pop,将其位置的值-1.相当于寻找最靠右的和>0的后缀. 也就是线段树区间加减,寻找最靠右侧的大于0的数的位置,记录个区间最大值就行了. 另,不知怎么回事,交到cf上RE1…… C. Nikita and stack time limit per test 2 seconds memory limit per test 256 me…
Nikita and stack time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output Nikita has a stack. A stack in this problem is a data structure that supports two operations. Operation push(x) puts an int…
大意: 给定m个栈操作push(x)或pop(), 栈空时pop()无作用, 每个操作有执行的时间$t$, 对于每个$0 \le i \le m$, 输出[1,i]的栈操作按时间顺序执行后栈顶元素. push看做1, pop看做-1, 线段维护后缀和, 栈顶即为第一个后缀和>0的位置 #include <iostream> #include <algorithm> #include <cstdio> #define REP(i,a,n) for(int i=a;i…
http://codeforces.com/contest/760/problem/E 题目大意:现在对栈有m个操作,但是顺序是乱的,现在每输入一个操作要求你输出当前的栈顶, 注意,已有操作要按它们的时间顺序进行. 思路:线段树好题啊啊,我们把push当成+1, pop当成-1,按操作的位置建立线段树,那么如何 寻找栈顶呢,我们计算每个点的后缀,栈顶就是下标最大的>0的后缀,我们拿后缀建立线段树, 剩下的就是区间加减法,和求区间最大值啦. #include<bits/stdc++.h>…
洛谷 Codeforces 思路 一开始想偏想到了DP,后来发现我SB了-- 考虑每个\(a_i<x\)的\(i\),记录它前一个和后一个到它的距离为\(L_i,R_i\),那么就有 \[ ans_k=\sum_{i=1}^n L_iR_{i+k-1} \] 显然把\(L\)数组翻转一下就是一个FFT了. 最后特判\(k=0\). 代码 #include<bits/stdc++.h> clock_t t=clock(); namespace my_std{ using namespace…
Description 题库链接 给你一个长度为 \(n\) 的序列 \(A\) ,和一个数 \(x\) ,对于每个 \(i= 0\sim n\) ,求有多少个非空子区间满足恰好有 \(i\) 个数 \(<x\) . \(1 \leq n \leq 2 \cdot 10^5\) Solution 我们用 \([A_i<x]\) 做一个前缀和,显然这是单调递增的.记前缀和为 \(i\) 的个数为 \(f_i\) . 显然对于 \(i=k,k\neq 0\) 答案就是 \[\sum_{i=0}^{…
A. Petr and a calendar time limit per test:2 seconds memory limit per test:256 megabytes input:standard input output:standard output Petr wants to make a calendar for current month. For this purpose he draws a table in which columns correspond to wee…
题目连接:Codeforces 442C Artem and Array 题目大意:给出一个数组,每次删除一个数.删除一个数的得分为两边数的最小值,假设左右有一边不存在则算作0分. 问最大得分是多少. 解题思路:首先将连续的a,b,c,a > b && c > b的情况将c掉,获得min(a,b)分,这样处理后数组变成一个递増再递减的序列,除了最大和第二大的取不到.其它数字均能够得分. 例子:4 10 2 2 8 #include <cstdio> #include…
题目链接:http://codeforces.com/contest/877/problem/B Nikita and string time limit per test2 seconds memory limit per test256 megabytes Nikita thinks that string is beautiful if it can be cut into 3 strings (possibly empty) without changing the order of t…